#CMFBlogger licensed under ZPL 
#NOTE: current bug requires USERNAME to be Manager ;(
from testClient import invokeClient

USERNAME='uname'
PASSWORD='pword'
URL='http://localhost:8080/collective/portal_weblog'
APPKEY='blogtest'
CONTENT="""\
This is some test content.  We could use lorem ipsum but that would require a googling. 
I can't believe I'm writing unit tests for a freakin BloggerTool.  What overkill.
"""
BLOGID='home'

def testUserInfo(client):
    result = client.portal_weblog.blogger.getUserInfo(APPKEY,USERNAME,PASSWORD)
    assert result, 'Could not return information using login:%s and password:%s' % (USERNAME, PASSWORD)
    assert type(result) == type({}), 'testUserInfo must return a struct'
    for key in ['name','email','url','userid','firstname','lastname']:
        assert result.get(key),'testUserInfo struct must contain "%s" key' % key

def testNewPost(client):
    assert client.portal_weblog.blogger.newPost(APPKEY, BLOGID,USERNAME,PASSWORD,CONTENT,0), 'Could not post new content'

def testEditPost(client):
    postings=client.portal_weblog.blogger.getRecentPosts(APPKEY, BLOGID,USERNAME,PASSWORD)
    if len(postings):
        result=postings[0]
        new_content=''.join(result['content'].split(' '))
        client.portal_weblog.blogger.editPost(APPKEY, result['postid'],USERNAME,PASSWORD, new_content, 0)
    postings=client.portal_weblog.blogger.getRecentPosts(APPKEY, BLOGID, USERNAME,PASSWORD)
    if len(postings):
        result=postings[0]
        new_content=''.join(CONTENT.split(' '))
        assert result['content']==new_content, 'The text of the Posting is incorrect'
    
def testDeletePost(client):
    postings=client.portal_weblog.blogger.getRecentPosts(APPKEY, BLOGID,USERNAME,PASSWORD)
    if len(postings):
        result=postings[0]
        assert client.portal_weblog.blogger.deletePost(APPKEY, result['postid'],USERNAME,PASSWORD, 0), 'Deleting Blog Entry, ' + resulti['postid'] + ' failed.'

def testListPostings(client):
    result = client.portal_weblog.blogger.getRecentPosts(APPKEY, BLOGID, USERNAME,PASSWORD)
    assert len(result), 'Could not get list Blog Entries'
    assert type(result) == type([]) or type(result) == type(()),'getRecentPosts must return a sequence'
    for post in result:
        assert type(post) == type({}),'getRecentPosts sequence must contain structs'
        for key in ['postid','dateCreated','userid','content']:
            assert post.get(key),'getRecentPosts struct must contain "%s" key' % key
    
def testGetUsersBlogs(client):
    result = client.portal_weblog.blogger.getUsersBlogs(APPKEY,USERNAME,PASSWORD)
    assert len(result), 'Could not get Users Blogs'
    assert type(result) == type([]) or type(result) == type(()), 'getUsersBlogs must return sequence'
    for blog in result:
        assert type(blog) == type({}),'getUsersBlogs sequence must contain structs'
        for key in 'url','blogid','blogname':
            assert blog.get(key),'getUsersBlogs struct must contain "%s" key' % key

if __name__=='__main__':
    import xmlrpclib
    xmlrpcClient=xmlrpclib.Server(URL)
    testUserInfo(xmlrpcClient)
    testGetUsersBlogs(xmlrpcClient)
    testNewPost(xmlrpcClient)
    testEditPost(xmlrpcClient)
    testListPostings(xmlrpcClient)
    testDeletePost(xmlrpcClient)


